unit UBonHmot;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  vzorce, Db, StdCtrls, ExtCtrls, Grids, DBGrids, DBTables;

type
  TSpBonHmot = class(TForm)
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Panel1: TPanel;
    Button1: TButton;
    Table1: TTable;
    Table1DREVINA: TStringField;
    Table1BONITA: TFloatField;
    Table1VEK: TFloatField;
    Table1VYSKA: TFloatField;
    Table1TLOUSTKA: TFloatField;
    Table1HMOT: TFloatField;
    Table2: TTable;
    Table2vyska: TFloatField;
    Table2tloustka: TFloatField;
    Table2drevina: TStringField;
    Table2hmot: TFloatField;
    DBGrid2: TDBGrid;
    DataSource2: TDataSource;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
   procedure vygenerujTabulku;
   procedure vygenerujBonHmot;
  end;

var
  SpBonHmot: TSpBonHmot;

implementation

{$R *.DFM}
procedure TSpBonHmot.vygenerujBonHmot;
var
 iDrevina:Drevina;
 ITloustka,IVyska:integer;
 StrDrevina:string;
 iKoef,vh,vk,zh,zk:double;
 begin
  table2.CreateTable;
  table2.open;
  for iDrevina:=sm to dg do
   begin
    for iVyska:=7 to 40 do
      begin
       for ITloustka:=7 to 80 do
        begin
         table2.insert;
         StrDrevina:=prev_dr_na_st(iDrevina);
         table2.fieldByName('DREVINA').asstring:=StrDrevina;
         table2.fieldByName('VYSKA').asInteger:=IVyska;
         table2.fieldByName('TLOUSTKA').asInteger:=ITloustka;
         Ikoef:=IVyska/ITloustka;
         if (Ikoef<1.9)and(Ikoef>0.25) then
          begin
           vrat_tab_hod(IDrevina,iTloustka,iVyska,vh,vk,zh,zk);
           table2.fieldByName('Hmot').asfloat:=round(vh*100)/100;
          end;
         table2.post;
        end;
      end;
   end;
  table2.close;
  table2.open;
 end;
procedure TSpBonHmot.vygenerujTabulku;
 var
 iDrevina:Drevina;
 iAVB,iVek:integer;
 StrDrevina:string;
 VVyska,OVyska,OTloustka:real;
 vh,vk,zh,zk:double;
 begin
  table1.CreateTable;
  table1.open;
  for iDrevina:=sm to dg do
   begin
    iAVB:=pmima[idrevina].bmin;
    while iAVB<=pmima[idrevina].bmax do
     begin
      iVek:=15;
      while iVek<=max_vek_pro_bon[idrevina] do
       begin
        table1.insert;
        StrDrevina:=prev_dr_na_st(iDrevina);
        table1.fieldByName('DREVINA').asstring:=StrDrevina;
        table1.fieldByName('BONITA').asinteger:=iAVB;
        table1.fieldByName('VEK').asinteger:=iVEK;
        VVyska:=vyska_bon(IDrevina,iVek,iAVB);
        OVyska:=vyska_bon_stat_dyn(IDrevina,iVek,iAVB);
        table1.fieldByName('VYSKA').asfloat:=round(OVyska*10)/10;
        table1.fieldByName('HMOT').asfloat:=0;
        OTloustka:= tloust_dle_vysky_a_veku(IDrevina,iVek,OVyska);
        table1.fieldByName('TLOUSTKA').asfloat:=round(OTloustka*10)/10;
        vrat_tab_hod(IDrevina,OTloustka,OVyska,vh,vk,zh,zk);
        table1.fieldByName('HMOT').asfloat:=round(vh*100)/100;
        // tdr:drevina;d,h:double; var vh,vk,zh,zk:double);
        table1.post;
        IVek:=IVek+5
       end;
      iAVB:=iAVB+2;
     end;
   end;
  table1.close;
  table1.open;
 end;

procedure TSpBonHmot.Button1Click(Sender: TObject);
begin
 vygenerujTabulku;
end;

procedure TSpBonHmot.Button2Click(Sender: TObject);
begin
 vygenerujBonHmot;
end;

end.
